


import org.eclipse.jetty.http.HttpHeader;
import org.json.JSONObject;

import java.net.PasswordAuthentication;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.http.HttpClient;
import java.net.http.HttpHeaders;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;


public class ApiCall {
    private static String token ="0";
    private static String oldId="1";

    public static String FetchDataFromApi(String extension) throws InterruptedException, ExecutionException, TimeoutException {

        final String username = "kevin.shehu@hochschule-rhein-waal.de";
        final String password = "DK7SxFkGJgnLhnU3";
        String baseURL = "https://api.dev.whysor.com/";
        String outputToken = null;

        if (token.equals(oldId)){
            //do nothing
        }
        else {
            SecurityToken securityToken = new SecurityToken();
            try {
                outputToken = securityToken.OnCallMethod(username,password);
                JSONObject obj = new JSONObject(outputToken);
                token = obj.getString("id");
                oldId = token;
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (ExecutionException e) {
                e.printStackTrace();
            } catch (TimeoutException e) {
                e.printStackTrace();
            }
        }




        System.out.println(token);
        var client = HttpClient.newBuilder()
                .version(HttpClient.Version.HTTP_1_1)
                .followRedirects(HttpClient.Redirect.ALWAYS)
                .build();
        HttpRequest request = null;

        try {

            request = HttpRequest.newBuilder(new URI(baseURL+extension))
                    .POST(HttpRequest.BodyPublishers.ofString(extension))
                    .setHeader("Authorization" , token)
                    .setHeader("Content-Type", "application/json")
                    .setHeader("Accept", "application/json")
                    .build();

        } catch (URISyntaxException e) {
            e.printStackTrace();
        }

        CompletableFuture<HttpResponse<String>> response = client.sendAsync(request, HttpResponse.BodyHandlers.ofString());
        String result = response.thenApply(HttpResponse::body).get(5, TimeUnit.SECONDS);
        return result;


    }

    
}
