import java.util.TimerTask;
import java.util.Date;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

// Create a class extends with TimerTask
public class ScheduledTask extends TimerTask {

    Date now; // to display current time

    // Add your task here
    public void run() {
        // Display current time
        now = new Date(); // initialize date
        System.out.println("Time is :" + now);
        ApiCall apiCall = new ApiCall();
        String output = null;
        try {
            output = apiCall.FetchDataFromApi("devices");
        } catch (InterruptedException e) {
            e.printStackTrace();
        } catch (ExecutionException e) {
            e.printStackTrace();
        } catch (TimeoutException e) {
            e.printStackTrace();
        }
        System.out.println("Output :" + output); // Display current output
    }
}